{$ifdef FPC}{$mode delphi}{$endif}
unit Shader;

interface
  uses dglOpenGL;
  
  function SimpleProgram(const ShaderFile: string): glHandle;

implementation
uses utils {$ifdef WIN32}, windows {$endif};

procedure AttachShaderFile(target: glHandle; const fname: string; typ: GLuInt);
var
  src: string;
  psrc: pchar;
  shader: glHandle;
begin
  src := FileToString(fname);
  psrc := @src[1];
  
  shader := glCreateShader(typ);
  glShaderSource(shader, 1, @psrc, nil);
  glCompileShader(shader);
  glAttachShader(target, shader);
  glDeleteShader(shader);
end;

function SimpleProgram(const ShaderFile: string): glHandle;
var
  log: string;
  log_len: longword;
begin
  result := glCreateProgram();
  AttachShaderFile(result, ShaderFile+'_vs.glsl', GL_VERTEX_SHADER);
  AttachShaderFile(result, ShaderFile+'_fs.glsl', GL_FRAGMENT_SHADER);
  glLinkProgram(result);
  
  glGetProgramiv(result, GL_INFO_LOG_LENGTH, @log_len);
  SetLength(log, log_len);
  glGetProgramInfoLog(result, log_len, log_len, @log[1]);
  
  if CharInString(':', log) then
  begin
    {$ifdef WIN32}
    MessageBox(0, pchar(log), 'Fehler', MB_SYSTEMMODAL or MB_ICONERROR);
    {$else}
    writeln(stderr, log);
    {$endif}
    halt(0);
  end;
end;

end. 