{$ifdef FPC}{$mode delphi}{$endif}
unit TGA;

interface
  
  function LoadTGA(const filename: string): longword;

implementation
uses dglOpenGL;

type
  TTGAFile = record
    iType: byte;  // Should be 2
     w, h: word;  // Width, Height
      bpp: byte;  // Byte per Pixel
     data: ^byte; // Pixels, dynamic length
  end;
  
function ReadTGAFile(const filename: string): TTGAFile;
var f: file; bytes: longword;
begin
  assign(f, filename);
  reset(f, 1);
 
  // type
  seek(f, 2);
  blockread(f, result.iType, 1);
 
  // w, h, bpp
  seek(f, 12);
  blockread(f, result.w, 5);
  result.bpp := result.bpp div 8;
 
  // data
  bytes := result.w * result.h * result.bpp;
  getmem(result.data, bytes);
  seek(f, 18);
  blockread(f, result.data^, bytes);
 
  close(f);
end;

function LoadTGA(const filename: string): longword;
var
  glFormat: longword;
  tex: TTGAFile;
begin
  tex := ReadTGAFile(filename);
  
  if tex.iType = 2 then
  begin
    glGenTextures(1, @result);
    glBindTexture(GL_TEXTURE_2D, result);
    
    if tex.bpp = 3 then glFormat := GL_BGR else glFormat := GL_BGRA;
 
    glTexImage2D(GL_TEXTURE_2D, 0, tex.bpp, tex.w, tex.h,
      0, glFormat, GL_UNSIGNED_BYTE, tex.data);
 
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  end;
  
  FreeMem(tex.data);
end;

end. 