{$ifdef FPC}{$mode delphi}{$endif}
unit utils;

interface
  type
    TStringArray = array of string;
  
  function FileToString(const path: string): string;
  function CharInString(chr: char; const str: string): boolean;
  function Split(const s: string; var L, R: string; op: char = ' '):boolean;

implementation
uses sysutils;

function FileToString(const path: string): string;
var
  f: file;
  len: longword;
begin
  AssignFile(f, path);
  reset(f,1);
  len := FileSize(f);
  SetLength(result, len);
  blockread(f, result[1], len);
  close(f);
end;

function CharInString(chr: char; const str: string): boolean;
var
  i: integer;
begin
  for i := 1 to length(str) do
    if str[i] = chr then exit(true);
    
  result := false;
end;

function Split(const s: string; var L, R: string; op: char = ' '):boolean;
var 
  opPos: word;
begin
  result := false;
  
  for opPos := 1 to length(s) do
    if s[opPos] = op then
    begin
      result := true;
      break;
    end;
    
  if result then
  begin
    L := copy(s, 1, opPos-1);
    R := copy(s, opPos+1, length(s)-opPos);
  end
  else
  begin
    L := s;
    R := '';
  end;
end;

end. 